

object.prototype.toHTML = function(node) {
	var el = newEl('div', {
		className: 'object'
	});
	node.appendChild(el);
	for (var i in this.messages) {
		this.messages[i].toHTML(el);
	}
};

lambda.prototype.toHTML = function(node) {
	var el = newEl('div', {
		className: 'lambda'
	});
	for (var i in this.args) {
		this.args[i].toHTML(el);
	}
	var body = newEl('div', {
		className: 'lambdabody'
	});
	for (var i in this.expressions) {
		this.expressions[i].toHTML(body);
	}
	el.appendChild(body);
	node.appendChild(el);
};

assignment.prototype.toHTML = function(node) {
	var base = newEl('div', {
		className: 'assignment'
	});
	var varName = newEl('span', {
		textContent: this.symbol.name + ' <-'
	});
	base.appendChild(varName);
	node.appendChild(base);
	this.expression.toHTML(base);
};

op.prototype.toHTML = function(node) {
	var base = newEl('span', {
		className: 'op'
	});
	this.left.toHTML(base);
	base.appendChild(newEl('span', {
		textContent: this.op,
		className: 'opname'
	}));
	this.right.toHTML(base);
	node.appendChild(base);
};

intlit.prototype.toHTML = function(node) {
	node.appendChild(newEl('span', {
		className: 'integer',
		textContent: this.val
	}));
};

floatlit.prototype.toHTML = function(node) {
	node.appendChild(newEl('span', {
		className: 'float',
		textContent: this.val
	}));
};

strlit.prototype.toHTML = function(node) {
	node.appendChild(newEl('span', {
		className: 'string',
		textContent: this.val
	}));
};

funcall.prototype.toHTML = function(node) {
	var base = newEl('div', {
		className: 'funcall'
	});
	var parts = this.name.split(':');
	for (var i in parts ) {
		if(parts[i]) {
			base.appendChild(newEl('span', {textContent: parts[i] + ':', className: 'funpart'}));
			if (this.args[i]) {
				this.args[i].toHTML(base);
			}
		}
	}
	for (; i < this.args.length; i++) {
		this.args[i].toHTML(base);
	}
	node.appendChild(base);
};

symbol.prototype.toHTML = function(node) {
	var astNode = this;
	node.appendChild(newEl('span', {
		className: 'symbol',
		textContent: this.name,
		onclick: function() {
			return mainModule.symbolClick(this, astNode);
		}
	}));
}
